# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 4.6.0-SNAPSHOT
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus_client.com.termlex.pathnexus.model.codeable_concept import CodeableConcept  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.coding import Coding  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.extension import Extension  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.quantity import Quantity  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.range import Range  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.reference import Reference  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.string_type import StringType  # noqa: F401,E501
from pathnexus_client.com.termlex.pathnexus.model.type import Type  # noqa: F401,E501


class UsageContext(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'format_comments_pre': 'list[str]',
        'format_comments_post': 'list[str]',
        'id': 'str',
        'extension': 'list[Extension]',
        'disallow_extensions': 'bool',
        'code': 'Coding',
        'value': 'Type',
        'value_codeable_concept': 'CodeableConcept',
        'value_quantity': 'Quantity',
        'value_range': 'Range',
        'value_reference': 'Reference',
        'empty': 'bool',
        'extension_first_rep': 'Extension',
        'id_element': 'StringType',
        'id_base': 'str',
        'primitive': 'bool',
        'resource': 'bool',
        'boolean_primitive': 'bool',
        'date_time': 'bool'
    }

    attribute_map = {
        'format_comments_pre': 'formatCommentsPre',
        'format_comments_post': 'formatCommentsPost',
        'id': 'id',
        'extension': 'extension',
        'disallow_extensions': 'disallowExtensions',
        'code': 'code',
        'value': 'value',
        'value_codeable_concept': 'valueCodeableConcept',
        'value_quantity': 'valueQuantity',
        'value_range': 'valueRange',
        'value_reference': 'valueReference',
        'empty': 'empty',
        'extension_first_rep': 'extensionFirstRep',
        'id_element': 'idElement',
        'id_base': 'idBase',
        'primitive': 'primitive',
        'resource': 'resource',
        'boolean_primitive': 'booleanPrimitive',
        'date_time': 'dateTime'
    }

    def __init__(self, format_comments_pre=None, format_comments_post=None, id=None, extension=None, disallow_extensions=None, code=None, value=None, value_codeable_concept=None, value_quantity=None, value_range=None, value_reference=None, empty=None, extension_first_rep=None, id_element=None, id_base=None, primitive=None, resource=None, boolean_primitive=None, date_time=None):  # noqa: E501
        """UsageContext - a model defined in Swagger"""  # noqa: E501

        self._format_comments_pre = None
        self._format_comments_post = None
        self._id = None
        self._extension = None
        self._disallow_extensions = None
        self._code = None
        self._value = None
        self._value_codeable_concept = None
        self._value_quantity = None
        self._value_range = None
        self._value_reference = None
        self._empty = None
        self._extension_first_rep = None
        self._id_element = None
        self._id_base = None
        self._primitive = None
        self._resource = None
        self._boolean_primitive = None
        self._date_time = None
        self.discriminator = None

        if format_comments_pre is not None:
            self.format_comments_pre = format_comments_pre
        if format_comments_post is not None:
            self.format_comments_post = format_comments_post
        if id is not None:
            self.id = id
        if extension is not None:
            self.extension = extension
        if disallow_extensions is not None:
            self.disallow_extensions = disallow_extensions
        if code is not None:
            self.code = code
        if value is not None:
            self.value = value
        if value_codeable_concept is not None:
            self.value_codeable_concept = value_codeable_concept
        if value_quantity is not None:
            self.value_quantity = value_quantity
        if value_range is not None:
            self.value_range = value_range
        if value_reference is not None:
            self.value_reference = value_reference
        if empty is not None:
            self.empty = empty
        if extension_first_rep is not None:
            self.extension_first_rep = extension_first_rep
        if id_element is not None:
            self.id_element = id_element
        if id_base is not None:
            self.id_base = id_base
        if primitive is not None:
            self.primitive = primitive
        if resource is not None:
            self.resource = resource
        if boolean_primitive is not None:
            self.boolean_primitive = boolean_primitive
        if date_time is not None:
            self.date_time = date_time

    @property
    def format_comments_pre(self):
        """Gets the format_comments_pre of this UsageContext.  # noqa: E501


        :return: The format_comments_pre of this UsageContext.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_pre

    @format_comments_pre.setter
    def format_comments_pre(self, format_comments_pre):
        """Sets the format_comments_pre of this UsageContext.


        :param format_comments_pre: The format_comments_pre of this UsageContext.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_pre = format_comments_pre

    @property
    def format_comments_post(self):
        """Gets the format_comments_post of this UsageContext.  # noqa: E501


        :return: The format_comments_post of this UsageContext.  # noqa: E501
        :rtype: list[str]
        """
        return self._format_comments_post

    @format_comments_post.setter
    def format_comments_post(self, format_comments_post):
        """Sets the format_comments_post of this UsageContext.


        :param format_comments_post: The format_comments_post of this UsageContext.  # noqa: E501
        :type: list[str]
        """

        self._format_comments_post = format_comments_post

    @property
    def id(self):
        """Gets the id of this UsageContext.  # noqa: E501


        :return: The id of this UsageContext.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UsageContext.


        :param id: The id of this UsageContext.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def extension(self):
        """Gets the extension of this UsageContext.  # noqa: E501


        :return: The extension of this UsageContext.  # noqa: E501
        :rtype: list[Extension]
        """
        return self._extension

    @extension.setter
    def extension(self, extension):
        """Sets the extension of this UsageContext.


        :param extension: The extension of this UsageContext.  # noqa: E501
        :type: list[Extension]
        """

        self._extension = extension

    @property
    def disallow_extensions(self):
        """Gets the disallow_extensions of this UsageContext.  # noqa: E501


        :return: The disallow_extensions of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._disallow_extensions

    @disallow_extensions.setter
    def disallow_extensions(self, disallow_extensions):
        """Sets the disallow_extensions of this UsageContext.


        :param disallow_extensions: The disallow_extensions of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._disallow_extensions = disallow_extensions

    @property
    def code(self):
        """Gets the code of this UsageContext.  # noqa: E501


        :return: The code of this UsageContext.  # noqa: E501
        :rtype: Coding
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this UsageContext.


        :param code: The code of this UsageContext.  # noqa: E501
        :type: Coding
        """

        self._code = code

    @property
    def value(self):
        """Gets the value of this UsageContext.  # noqa: E501


        :return: The value of this UsageContext.  # noqa: E501
        :rtype: Type
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this UsageContext.


        :param value: The value of this UsageContext.  # noqa: E501
        :type: Type
        """

        self._value = value

    @property
    def value_codeable_concept(self):
        """Gets the value_codeable_concept of this UsageContext.  # noqa: E501


        :return: The value_codeable_concept of this UsageContext.  # noqa: E501
        :rtype: CodeableConcept
        """
        return self._value_codeable_concept

    @value_codeable_concept.setter
    def value_codeable_concept(self, value_codeable_concept):
        """Sets the value_codeable_concept of this UsageContext.


        :param value_codeable_concept: The value_codeable_concept of this UsageContext.  # noqa: E501
        :type: CodeableConcept
        """

        self._value_codeable_concept = value_codeable_concept

    @property
    def value_quantity(self):
        """Gets the value_quantity of this UsageContext.  # noqa: E501


        :return: The value_quantity of this UsageContext.  # noqa: E501
        :rtype: Quantity
        """
        return self._value_quantity

    @value_quantity.setter
    def value_quantity(self, value_quantity):
        """Sets the value_quantity of this UsageContext.


        :param value_quantity: The value_quantity of this UsageContext.  # noqa: E501
        :type: Quantity
        """

        self._value_quantity = value_quantity

    @property
    def value_range(self):
        """Gets the value_range of this UsageContext.  # noqa: E501


        :return: The value_range of this UsageContext.  # noqa: E501
        :rtype: Range
        """
        return self._value_range

    @value_range.setter
    def value_range(self, value_range):
        """Sets the value_range of this UsageContext.


        :param value_range: The value_range of this UsageContext.  # noqa: E501
        :type: Range
        """

        self._value_range = value_range

    @property
    def value_reference(self):
        """Gets the value_reference of this UsageContext.  # noqa: E501


        :return: The value_reference of this UsageContext.  # noqa: E501
        :rtype: Reference
        """
        return self._value_reference

    @value_reference.setter
    def value_reference(self, value_reference):
        """Sets the value_reference of this UsageContext.


        :param value_reference: The value_reference of this UsageContext.  # noqa: E501
        :type: Reference
        """

        self._value_reference = value_reference

    @property
    def empty(self):
        """Gets the empty of this UsageContext.  # noqa: E501


        :return: The empty of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._empty

    @empty.setter
    def empty(self, empty):
        """Sets the empty of this UsageContext.


        :param empty: The empty of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._empty = empty

    @property
    def extension_first_rep(self):
        """Gets the extension_first_rep of this UsageContext.  # noqa: E501


        :return: The extension_first_rep of this UsageContext.  # noqa: E501
        :rtype: Extension
        """
        return self._extension_first_rep

    @extension_first_rep.setter
    def extension_first_rep(self, extension_first_rep):
        """Sets the extension_first_rep of this UsageContext.


        :param extension_first_rep: The extension_first_rep of this UsageContext.  # noqa: E501
        :type: Extension
        """

        self._extension_first_rep = extension_first_rep

    @property
    def id_element(self):
        """Gets the id_element of this UsageContext.  # noqa: E501


        :return: The id_element of this UsageContext.  # noqa: E501
        :rtype: StringType
        """
        return self._id_element

    @id_element.setter
    def id_element(self, id_element):
        """Sets the id_element of this UsageContext.


        :param id_element: The id_element of this UsageContext.  # noqa: E501
        :type: StringType
        """

        self._id_element = id_element

    @property
    def id_base(self):
        """Gets the id_base of this UsageContext.  # noqa: E501


        :return: The id_base of this UsageContext.  # noqa: E501
        :rtype: str
        """
        return self._id_base

    @id_base.setter
    def id_base(self, id_base):
        """Sets the id_base of this UsageContext.


        :param id_base: The id_base of this UsageContext.  # noqa: E501
        :type: str
        """

        self._id_base = id_base

    @property
    def primitive(self):
        """Gets the primitive of this UsageContext.  # noqa: E501


        :return: The primitive of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._primitive

    @primitive.setter
    def primitive(self, primitive):
        """Sets the primitive of this UsageContext.


        :param primitive: The primitive of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._primitive = primitive

    @property
    def resource(self):
        """Gets the resource of this UsageContext.  # noqa: E501


        :return: The resource of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this UsageContext.


        :param resource: The resource of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._resource = resource

    @property
    def boolean_primitive(self):
        """Gets the boolean_primitive of this UsageContext.  # noqa: E501


        :return: The boolean_primitive of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._boolean_primitive

    @boolean_primitive.setter
    def boolean_primitive(self, boolean_primitive):
        """Sets the boolean_primitive of this UsageContext.


        :param boolean_primitive: The boolean_primitive of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._boolean_primitive = boolean_primitive

    @property
    def date_time(self):
        """Gets the date_time of this UsageContext.  # noqa: E501


        :return: The date_time of this UsageContext.  # noqa: E501
        :rtype: bool
        """
        return self._date_time

    @date_time.setter
    def date_time(self, date_time):
        """Sets the date_time of this UsageContext.


        :param date_time: The date_time of this UsageContext.  # noqa: E501
        :type: bool
        """

        self._date_time = date_time

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UsageContext):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
